/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.cosmodas.EntCosmos;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author obper
 */
@Entity
@Table(name = "documentos")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "Documentos.findAll", query = "SELECT d FROM Documentos d"),
        @NamedQuery(name = "Documentos.findByDocumentoCodigo", query = "SELECT d FROM Documentos d WHERE d.documentoCodigo = :documentoCodigo"),
        @NamedQuery(name = "Documentos.findByDocumentoNombre", query = "SELECT d FROM Documentos d WHERE d.documentoNombre = :documentoNombre"),
        @NamedQuery(name = "Documentos.findByDocIn", query = "SELECT d FROM Documentos d WHERE d.documentoCodigo IN ('07','08','09','10','17','16','SO','SY','CE','SA','SM','ZA','CH') ORDER BY d.documentoNombre"),
        @NamedQuery(name = "Documentos.findByDocumentoSiguiente", query = "SELECT d FROM Documentos d WHERE d.documentoSiguiente = :documentoSiguiente")})
public class Documentos implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2)
    @Column(name = "documento_codigo")
    private String documentoCodigo;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 30)
    @Column(name = "documento_nombre")
    private String documentoNombre;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 6)
    @Column(name = "documento_siguiente")
    private String documentoSiguiente;
    @JoinColumn(name = "tabla_codigo", referencedColumnName = "tabla_codigo")
    @ManyToOne(optional = false)
    private Tablas tablaCodigo;

    public Documentos() {
    }

    public Documentos(String documentoCodigo) {
        this.documentoCodigo = documentoCodigo;
    }

    public Documentos(String documentoCodigo, String documentoNombre, String documentoSiguiente) {
        this.documentoCodigo = documentoCodigo;
        this.documentoNombre = documentoNombre;
        this.documentoSiguiente = documentoSiguiente;
    }

    public String getDocumentoCodigo() {
        return documentoCodigo;
    }

    public void setDocumentoCodigo(String documentoCodigo) {
        this.documentoCodigo = documentoCodigo;
    }

    public String getDocumentoNombre() {
        return documentoNombre;
    }

    public void setDocumentoNombre(String documentoNombre) {
        this.documentoNombre = documentoNombre;
    }

    public String getDocumentoSiguiente() {
        return documentoSiguiente;
    }

    public void setDocumentoSiguiente(String documentoSiguiente) {
        this.documentoSiguiente = documentoSiguiente;
    }

    public Tablas getTablaCodigo() {
        return tablaCodigo;
    }

    public void setTablaCodigo(Tablas tablaCodigo) {
        this.tablaCodigo = tablaCodigo;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (documentoCodigo != null ? documentoCodigo.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Documentos)) {
            return false;
        }
        Documentos other = (Documentos) object;
        if ((this.documentoCodigo == null && other.documentoCodigo != null) || (this.documentoCodigo != null && !this.documentoCodigo.equals(other.documentoCodigo))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "dbcon.Documentos[ documentoCodigo=" + documentoCodigo + " ]";
    }

}
